/*****************************************************************************
  Pocket BASIC

  |PRBASICC^[v^

  Choi Kyun

  2009-10

  ver 0.1.0
*****************************************************************************/



/*
 * basic.h
 *
 * header file for tiny_basic
 *
 * This wizard-generated code is based on code adapted from the
 * stationery files distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1999-2000 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */



#ifndef INCLUDED_BASIC_H
#define INCLUDED_BASIC_H

#ifdef GLOBAL_VALUE_DEFINE
#define GLOBAL
#define GLOBAL_VAL(v) = (v)
#else
#define GLOBAL extern
#define GLOBAL_VAL(v)
#endif



//// e`

#define MAX_PROGRAM_AREA_NUM (10) // vOGA@ő10 P0-P9
#define MAX_PROGRAM_SIZE (4096+2) // 1GA̍őR[hTCY 4KB
#define MAX_LINE_SIZE (81) // 1s̍őTCY
#define MAX_LINE_NUMBER (9999)
#define MAX_STRING_VAR (62) // ϐő
#define GO_STACK_SIZE (8) // X^bN
#define FOR_STACK_SIZE (4)

#define ROUND_POW (-11) // ۂ߂̌ double 11Ŋۂ

#define FRAME_SEC (50) // 1b 50 t[

#define CUSTOM_FONT ((FontID)fntAppFontCustomBase)


// G[R[h
#define ERR_SE	0	// Syntax error
#define ERR_OM	1	// Out of memory
#define ERR_MG	2	// GOSUB or FOR nest exceeded
#define ERR_WG	3	// RETURN without GOSUB
#define ERR_EC	4	// Expression too complex
#define ERR_IL	5	// Illegal line number
#define ERR_DZ	6	// Division by zero
#define ERR_OR	7	// Index out of range
#define ERR_TM  8	// Variable type mismatch
#define ERR_LG  9	// String too long
#define ERR_NX 10	// NEXT withoout FOR
#define ERR_DO 11	// Data out of range
#define ERR_UL 12	// Undefined line

// g[NR[h
#define TOKEN_NULL		0
#define TOKEN_ERROR		1

// ϐ,萔
#define TOKEN_NUMBER	2 // 
//#define TOKEN_NUMBERV	3
#define TOKEN_VAR	4 // lϐ
#define TOKEN_VAR_S	5 // ϐ
#define TOKEN_VAR_D	6 // ϐ

// R}h
#define TOKEN_IF		0x80
#define TOKEN_GOTO		0x81
#define TOKEN_GOSUB		0x82
#define TOKEN_RETURN		0x83
#define TOKEN_REM		0x84
#define TOKEN_PRINT		0x85
#define TOKEN_INPUT		0x86
#define TOKEN_KEY		0x87
#define TOKEN_RAN		0x88
#define TOKEN_END		0x89
#define TOKEN_FOR		0x8a
#define TOKEN_TO		0x8b
#define TOKEN_NEXT		0x8c
#define TOKEN_LET		0x8d
#define TOKEN_LOCATE		0x8e
#define TOKEN_VAC		0x8f
#define TOKEN_BEEP		0x90
#define TOKEN_COLOR		0x91
#define TOKEN_CLS		0x92
#define TOKEN_STEP		0x93

// ֐
#define TOKEN_LEN		0xc0
#define TOKEN_MID		0xc1
#define TOKEN_VAL		0xc2
#define TOKEN_STR		0xc3

// l֐
#define TOKEN_SIN		0xd0
#define TOKEN_COS		0xd1
#define TOKEN_TAN		0xd2
#define TOKEN_ASN		0xd3
#define TOKEN_ACS		0xd4
#define TOKEN_ATN		0xd5
#define TOKEN_LOG		0xd6
#define TOKEN_LN		0xd7
#define TOKEN_EXP		0xd8
#define TOKEN_SQR		0xd9
#define TOKEN_ABS		0xda
#define TOKEN_SGN		0xdb
#define TOKEN_INT		0xdc
#define TOKEN_FRAC		0xdd
#define TOKEN_TICK		0xde

// R}hȊO
#define TOKEN_THEN		0xdf

// L
#define TOKEN_STRING		0x22	// "
#define TOKEN_PERCENT		0x25	// %
#define TOKEN_PAREN_B		0x28	// (
#define TOKEN_PAREN_E		0x29	// )
#define TOKEN_ASTER		0x2a	// *
#define TOKEN_PLUS		0x2b	// +
#define TOKEN_MINUS		0x2d	// -
#define TOKEN_COMMA		0x2c	// ,
#define TOKEN_SLASH		0x2f	// /
#define TOKEN_COLON		0x3a	// :
#define TOKEN_SEMICOLON 	0x3b	// ;
#define TOKEN_PI		0x3c	// PI


// ֌WZq (bit2=<, bit1==, bit0=>)
#define TOKEN_EQ		0xe2	// %11110010	; =
#define TOKEN_NEQ		0xe5	// %11110101	; <> ><
#define TOKEN_LTE		0xe6	// %11110110	; <=
#define TOKEN_LT		0xe4	// %11110100	; <
#define TOKEN_GTE		0xe3	// %11110011	; >=
#define TOKEN_GT		0xe1	// %11110001	; >
#define TOKEN_ROPMIN		0xe1	// %11110001	; ֌WZqŏ
#define TOKEN_ROPMAX		0xe6	// %11110110	; ֌WZqő


// _
#define RND(N) ((((Int32) SysRandom (0)) * (N)) / ((Int32) sysRandomMax + 1))
// PI
#define PI 3.1415926535897932384626433832795029L

// COLOR
#define INDEX_BLACK 230



/*********************************************************************
 * Internal Structures
 *********************************************************************/
// ϐ PB-100 lϐ A-Z(double),ϐ A$-Z$(7)
typedef enum {
  NOT_USE,
  VARIABLE_NUM,
  VARIABLE_STR
} VariableModeType;

typedef enum {
  chr_nomal,
  chr_rem,
  chr_str
} GetCharModeType;

typedef enum {
  inp_off,
  inp_on,
  inp_continue,
  inp_end
} InputModeType;

typedef struct {
  VariableModeType type;
  union {
    double val;
    char str[8];
  } contents;
} VariableType;

// L[[he[u
typedef struct {
  char word[8];
  unsigned char code;
} KeywordType;

// g[N
typedef struct {
  UInt16 code;
  double value;
} TokenType;

// vt@X
typedef struct {
  int current_pa; // ݂̃GA
  int pa_free_size[ MAX_PROGRAM_AREA_NUM ]; // t[TCY
  int pa_last_number[ MAX_PROGRAM_AREA_NUM ]; // ŏIs
  int pa_last_ptr[ MAX_PROGRAM_AREA_NUM ]; // TCY
  int pa_num_lines[ MAX_PROGRAM_AREA_NUM ]; // s
} PocketBasicPreferenceType;


// FOR X^bN
typedef struct {
  char *top;
  char *read;
  int v;
  double g;
  double step;
} ForStackType;


// JX^tHg
typedef struct {
  MemHandle h;
  FontType *p;
  FontID old;
} CustomFontType;



/*********************************************************************
 * Global variables
 *********************************************************************/
// ϐ
GLOBAL VariableType g_variable[26]; // a-z,a$-z$
GLOBAL char g_special_strings[MAX_STRING_VAR+1]; // p

// L[R[h
GLOBAL UInt16 g_key_code;

// tB[h
GLOBAL UInt16 g_last_field_size;

// ݂̃vOGA
GLOBAL int g_current_pa;

// vOGAւ̃|C^
GLOBAL char (*g_pa_p)[ MAX_PROGRAM_SIZE ];

// vOGÃ|C^
GLOBAL int g_pa_curr_ptr;
GLOBAL int g_pa_last_ptr[ MAX_PROGRAM_AREA_NUM ];

// sԍ
GLOBAL int g_pa_curr_number;
GLOBAL int g_pa_last_number[ MAX_PROGRAM_AREA_NUM ];
GLOBAL int g_pa_num_lines[ MAX_PROGRAM_AREA_NUM ];

// vOGAt[TCY
GLOBAL int g_pa_free_size[ MAX_PROGRAM_AREA_NUM ];

// J[\W
GLOBAL PointType g_cursor;

// f[^x[X
GLOBAL DmOpenRef g_pa_db_p;
GLOBAL MemHandle g_pa_record_h;
GLOBAL MemPtr g_pa_record_p;

// g[N
GLOBAL char *g_token_top;

// s̍s̃|C^
GLOBAL char * g_line_top;

// s[h
GLOBAL Boolean g_run_mode;
GLOBAL int g_frame_tick;
GLOBAL UInt32 g_last_tick;
GLOBAL char *g_program_pointer; // ݂̎sʒu

GLOBAL int g_err_number;

GLOBAL int g_go_sp; // GOSUB X^bN
GLOBAL int g_for_sp; // FOR X^bN
GLOBAL char *g_go_stack[ GO_STACK_SIZE ][2];
GLOBAL ForStackType g_for_stack[ FOR_STACK_SIZE ];

// Cvbg
GLOBAL InputModeType g_input_state;
GLOBAL char g_input_buf[ MAX_STRING_VAR+1 ];
GLOBAL double g_input_dbl;
GLOBAL int g_input_skip;

GLOBAL CustomFontType g_font;



///////////////////////////////////////////////////////// }N

#define list_number(index) (*(int *)(&g_pa_p[g_current_pa][index])) // sԍ
#define list_length(index) (*(char *)(&g_pa_p[g_current_pa][index+2])) // oCg



/*********************************************************************
 * Internal Constants
 *********************************************************************/
void conv_ascii_to_basic( void );
void init_program_area( void );
void update_free_area( void );
void backward_edit_line( void );
void forward_edit_line( void );
void delete_line( int );
void flash_field( FieldPtr );

Err open_program_area_db( void );
void close_program_area_db( void );
void delete_program_area_db( void );

void execute( void );

void disp_edit_line( void );
void init_variable( void );
void new_list( void );

double a_to_f( char *s );



#endif /* INCLUDED_BASIC_H */
